#include<stdio.h>

int partition(int array[], int left, int right, int pivotIndex){
    int pivotValue = array[pivotIndex];

    int temp = array[pivotIndex];
    array[pivotIndex] = array[right];
    array[right] = temp;

    int storeIndex = left;
    int i = 0;
    for(i = left; i < right; i++){
        if(array[i] <= pivotValue){
            temp = array[i];
            array[i] = array[storeIndex];
            array[storeIndex] = temp;

            storeIndex++;
        }
    }

    temp = array[storeIndex];
    array[storeIndex] = array[right];
    array[right] = temp;

    return storeIndex;
}

void quicksort(int array[], int left, int right){
    if(left < right){
        int pivotIndex = left + floor((right - left) / 2);

        int newPivotIndex = partition(array, left, right, pivotIndex);

        quicksort(array, left, newPivotIndex - 1);
        quicksort(array, newPivotIndex + 1, right);
    }
}

main(){
    int i = 0;
    int scrambled[10] = {4, 8, 1, 5, 6, 2, 3, 0, 9, 7};

    /* printf unsorted array */
    for(i = 0; i < sizeof(scrambled) / sizeof(int); i++){
        printf("%d", scrambled[i]);
    }
    printf("\n");

    /* sort the array */
    quicksort(scrambled, 0, sizeof(scrambled) / sizeof(int) - 1);

    /* printf sorted array */
    for(i = 0; i < sizeof(scrambled) / sizeof(int); i++){
        printf("%d", scrambled[i]);
    }
}
