function partition(array, left, right, pivotIndex){
    var pivotValue = array[pivotIndex];

    var temp = array[pivotIndex];
    array[pivotIndex] = array[right];
    array[right] = temp;

    var storeIndex = left;
    var i = 0;
    for(i = left; i < right; i++){
        if(array[i] <= pivotValue){
            temp = array[i];
            array[i] = array[storeIndex];
            array[storeIndex] = temp;

            storeIndex++;
        }
    }

    temp = array[storeIndex];
    array[storeIndex] = array[right];
    array[right] = temp;

    return storeIndex;
}

function quicksort(array, left, right){
    if(left < right){
        var pivotIndex = left + Math.floor((right - left) / 2);

        var newPivotIndex = partition(array, left, right, pivotIndex);

        quicksort(array, left, newPivotIndex - 1);
        quicksort(array, newPivotIndex + 1, right);
    }
}

var scrambled = [4, 8, 1, 5, 6, 2, 3, 0, 9, 7];

// scrambled == [4, 8, 1, 5, 6, 2, 3, 0, 9, 7]

// sort the array
quicksort(scrambled, 0, scrambled.length - 1);

// scrambled == [0, 1, 2, 3, 4, 5, 6, 7, 8, 9]
