#!/usr/bin/env python3

class Page:
    def __init__(self,template):
        self.subs = dict()
        self.template = template

    def addSub(self,key,value):
        self.subs[key] = value

    def render(self):
        return self.template.format(**self.subs)


sample_page = Page("&lt;!doctype html&gt;\n&lt;meta charset=utf-8&gt;\n&lt;title&gt;{title}&lt;/title&gt;\n\n{content}")

sample_page.addSub('title','Sample Template')
sample_page.addSub('content','Sample page content rendered using a not yet ready Python-TemplateEngine.&lt;br&gt;\nHTML tags displayed for demonstration purposes.')

print(sample_page.render())
