#!/usr/bin/env python3
import math

def partition(array, left, right, pivotIndex):
    pivotValue = array[pivotIndex]

    array[pivotIndex], array[right] = array[right], array[pivotIndex]

    storeIndex = left
    for i in range(left, right):
        if array[i] <= pivotValue:
            array[i], array[storeIndex] = array[storeIndex], array[i]

            storeIndex += 1

    array[storeIndex], array[right] = array[right], array[storeIndex]

    return storeIndex

def quicksort(array, left, right):
    if left < right:
        pivotIndex = left + math.floor((right - left) / 2)

        newPivotIndex = partition(array, left, right, pivotIndex)

        quicksort(array, left, newPivotIndex - 1)
        quicksort(array, newPivotIndex + 1, right)


scrambled = [4, 8, 1, 5, 6, 2, 3, 0, 9, 7]

# print unsorted array
for value in scrambled:
    print(value)
print('\n')

# sort the array
quicksort(scrambled, 0, len(scrambled) - 1);

# print sorted array
for value in scrambled:
    print(value)
