#!/usr/bin/env ruby
def partition(array, left, right, pivotIndex)
    $pivotValue = array[pivotIndex]

    array[pivotIndex], array[right] = array[right], array[pivotIndex]

    $storeIndex = left
    for $i in left..right
        if array[$i] <= $pivotValue
            array[$i], array[$storeIndex] = array[$storeIndex], array[$i]

            $storeIndex += 1
        end
    end

    array[$storeIndex], array[right] = array[right], array[$storeIndex]

    return $storeIndex
end

def quicksort(array, left, right)
    if left < right
        $pivotIndex = left + ((right - left) / 2).floor;

        $newPivotIndex = partition(array, left, right, $pivotIndex);

        quicksort(array, left, $newPivotIndex - 1);
        quicksort(array, $newPivotIndex + 1, right);
    end
end

$scrambled = [4, 8, 1, 5, 6, 2, 3, 0, 9, 7]

# puts unsorted array
for $i in 0..$scrambled.size - 1
    puts $scrambled[$i]
end
puts "\n"

# sor the array
quicksort($scrambled, 0, $scrambled.size - 1);

# puts sorted array
for $i in 0..$scrambled.size - 1
    puts $scrambled[$i]
end

